using System;
using BepInEx.Configuration;
using HarmonyLib;

namespace TerraTech {
    [HarmonyPatch]
    public class ModuleWeaponManager {
        private static readonly MultipliedObjectManager<ModuleWeapon> manager =
            new MultipliedObjectManager<ModuleWeapon>(ConfigureManager);

        public static ConfigEntry<bool> playerOnly;
        public static ConfigEntry<float> rotateSpeedMultiplier;

        public static void Setup(ConfigFile config) {
            float min = 0.01f;
            float max = 32f;

            playerOnly = config.Bind("ModuleWeapon", "Player Only", false, new ConfigDescription("Player Only"));
            playerOnly.SettingChanged += (sender, args) => DoPatch();

            rotateSpeedMultiplier = config.Bind(
                "ModuleWeapon", "Rotate Speed Multiplier", 1f,
                new ConfigDescription("Rotate Speed Multiplier", new AcceptableValueRange<float>(min, max)));
            rotateSpeedMultiplier.SettingChanged += (sender, args) => DoPatch();
        }

        private static void ConfigureManager(MultipliedObject<ModuleWeapon> obj) {
            obj.AddField(new FieldConfiguration<float, float>("m_RotateSpeed", rotateSpeedMultiplier, ShouldApply));
        }

        private static readonly Func<object, bool> ShouldApply = obj => {
            if (!playerOnly.Value)
                return true;
            return CykUtil.IsPlayerTank(obj as Module);
        };

        [HarmonyPrefix]
        [HarmonyPatch(typeof(ModuleWeapon), "OnAttached")]
        static void PostfixCreate(ModuleWeapon __instance) {
            manager.OnObjectAttached(__instance);
        }

        [HarmonyPrefix]
        [HarmonyPatch(typeof(ModuleWeapon), "OnDetaching")]
        static void PostfixDestroy(ModuleWeapon __instance) {
            manager.OnObjectDetached(__instance);
        }

        public static void DoPatch() {
            manager.ApplyAll();
        }
    }
}
